-- Test set_campsite_type_pet_cost
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(12);

set search_path to camper, public;

select has_function('camper', 'set_campsite_type_pet_cost', array['uuid', 'text']);
select function_lang_is('camper', 'set_campsite_type_pet_cost', array['uuid', 'text'], 'sql');
select function_returns('camper', 'set_campsite_type_pet_cost', array['uuid', 'text'], 'void');
select isnt_definer('camper', 'set_campsite_type_pet_cost', array['uuid', 'text']);
select volatility_is('camper', 'set_campsite_type_pet_cost', array['uuid', 'text'], 'volatile');
select function_privs_are('camper', 'set_campsite_type_pet_cost', array ['uuid', 'text'], 'guest', array[]::text[]);
select function_privs_are('camper', 'set_campsite_type_pet_cost', array ['uuid', 'text'], 'employee', array[]::text[]);
select function_privs_are('camper', 'set_campsite_type_pet_cost', array ['uuid', 'text'], 'admin', array['EXECUTE']);
select function_privs_are('camper', 'set_campsite_type_pet_cost', array ['uuid', 'text'], 'authenticator', array[]::text[]);


set client_min_messages to warning;
truncate campsite_type_pet_cost cascade;
truncate campsite_type cascade;
truncate media cascade;
truncate media_content cascade;
truncate company cascade;
reset client_min_messages;


insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, rtc_number, tourist_tax, tourist_tax_max_days, country_code, currency_code, default_lang_tag)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', '', 60, 7, 'ES', 'EUR', 'ca')
;

insert into media_content (media_type, bytes)
values ('image/x-xpixmap', 'static char *s[]={"1 1 1 1","a c #ffffff","a"};')
;

insert into media (media_id, company_id, original_filename, content_hash)
values (2, 1, 'cover2.xpm', sha256('static char *s[]={"1 1 1 1","a c #ffffff","a"};'))
;

insert into campsite_type (campsite_type_id, company_id, slug, media_id, name, description, max_campers, bookable_nights, active)
values (3, 1, '87452b88-b48f-48d3-bb6c-0296de64164e', 2, 'Type A', '', 5, '[1, 7]', true)
     , (4, 1, '4ccf62bd-98f3-4239-8f25-a7534363cd98', 2, 'Type B', '', 5, '[1, 7]', true)
     , (5, 1, 'b16a8473-c40d-4ab9-b209-6fed03e1d14d', 2, 'Type C', '', 5, '[1, 7]', true)
;

insert into campsite_type_pet_cost (campsite_type_id, cost_per_night)
values (3, 333)
     , (4, 444)
;

select lives_ok(
	$$ select set_campsite_type_pet_cost('87452b88-b48f-48d3-bb6c-0296de64164e', '3.50') $$,
	'Should be able to edit the pet cost for first campsite type'
);

select lives_ok(
	$$ select set_campsite_type_pet_cost('b16a8473-c40d-4ab9-b209-6fed03e1d14d', '12.34') $$,
	'Should be able to add pet cost for third campsite type'
);

select bag_eq(
	$$ select campsite_type_id, cost_per_night from campsite_type_pet_cost $$,
	$$ values (3,  350)
	        , (4,  444)
	        , (5, 1234)
	$$,
	'Should have updated all campsite type pet costs.'
);


select *
from finish();

rollback;
